#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityMonsterCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityMonsterCFG> M_ActivityMonsterCFG::msSingleton(nullptr);

int M_ActivityMonsterCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityMonsterCFGData* M_ActivityMonsterCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityMonsterCFGData>& M_ActivityMonsterCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityMonsterCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityMonsterCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityMonsterCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mMonsterName = element->Attribute("MonsterName");
		data.mMonsterBlood = element->IntAttribute("MonsterBlood");
		data.mStar1 = element->IntAttribute("Star1");
		data.mStar2 = element->IntAttribute("Star2");
		data.mStar3 = element->IntAttribute("Star3");
		data.mFirstKillItem = element->IntAttribute("FirstKillItem");
		data.mFirstKillICount = element->IntAttribute("FirstKillICount");
		data.mKillItem = element->IntAttribute("KillItem");
		data.mKillICount = element->IntAttribute("KillICount");
		data.mResources = element->Attribute("Resources");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		assert(mMapData.find(data.mId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityMonsterCFG::Load()
{
	Load("../Config/M_ActivityMonsterCFG.xml");
}

M_ActivityMonsterCFG* M_ActivityMonsterCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityMonsterCFG());
	}
	return msSingleton.get();
}
